//------------------------------------------------------------------
#property copyright ""
#property link      ""
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int  PeriodEma       = 34;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = false;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;
   
double arrUp[];
double arrDn[];
double trendl[];
double trendh[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,arrUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
      SetIndexBuffer(1,arrDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
      SetIndexBuffer(2,trendl);
      SetIndexBuffer(3,trendh);
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
             int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i=limit; i>=0; i--)
      {
         double emah = iMA(NULL,0,PeriodEma,0,MODE_EMA,PRICE_HIGH,i);
         double emal = iMA(NULL,0,PeriodEma,0,MODE_EMA,PRICE_LOW ,i);
            trendl[i] = trendl[i+1];
            trendh[i] = trendh[i+1];
               if (Low[i] >emah) trendh[i] =  1;
               if (Low[i] <emah) trendh[i] = -1;
               if (High[i]>emal) trendl[i] =  1;
               if (High[i]<emal) trendl[i] = -1;
               if (trendl[i]!=trendl[i+1] && trendl[i]==-1) arrDn[i]=High[i]; else arrDn[i]=EMPTY_VALUE;
               if (trendh[i]!=trendh[i+1] && trendh[i]== 1) arrUp[i]=Low[i];  else arrUp[i]=EMPTY_VALUE;
      }   
      manageAlerts();
   return(0);      
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (trendl[whichBar] != trendl[whichBar+1]) if (trendl[whichBar] ==-1) doAlert(time1,mess1,whichBar," high crossed ema down");
      static datetime time2 = 0;
      static string   mess2 = "";
         if (trendh[whichBar] != trendh[whichBar+1]) if (trendh[whichBar] == 1) doAlert(time2,mess2,whichBar," low crossed ema up");
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"price cross "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}